#include "lpc2103.h"
#include "tools.h"
#include "l2f50126.h"

void int_sync (void)__attribute__ ((interrupt));
void int_timer0(void)__attribute__ ((interrupt));

unsigned int hsync=0;
unsigned int vsync=0;
unsigned int low_time=0;
unsigned int y=0;
unsigned int x=0;
unsigned int yp=0;
unsigned int xp=0;
unsigned int pixel=0;
unsigned char bild[60][60];

int main(void){
	APBDIV=1;
	pwm_background(30);
	lcd_init();
	fill_screen(BLACK);
	//externer interrupt
	PINSEL1 |= (1<<0);
    EXTMODE = (1<<0); //edge  
    EXTPOLAR = (0<<0); //falling
	VICVectAddr1 = (unsigned long)int_sync;
    VICVectCntl1 = 0x20|14;
    VICIntEnable |= (1<<14);
	//ende externer interrupt; anfang timer
	VICVectAddr3 = (unsigned long)int_timer0;
    VICVectCntl3 = 0x20|4;
    VICIntEnable |= (1<<4);
    T0MR0 = (5898640);	//100msec.
    T0MCR = 0x3;
	T0TCR = 1;
	//Ende
	IODIR |= (1<<10);
	init_timer3();
	PINSEL1 |= (1<<14)|(1<<15);	 //AD0.1
	ADCR = 0x300 + 0x200000 + 0x02 + (1<<18);	 //8 bit AD0.1
	while(1){


	}
}

unsigned short colorRGB (unsigned char r, unsigned char g, unsigned char b) 
{
	unsigned short color=0;
	r /= 8;
	g /= 4;
	b /= 8;
	color = (r<<11);
	color |= (g<<5);
	color |= b;
	return color;
}
unsigned short colorSW(unsigned char sw){
	return(colorRGB(sw,sw,sw));
}	



void int_sync (void){
	if (EXTPOLAR == (0<<0)){ //is falling
		T3TC = 0;
		IOCLR = (1<<10);
		EXTPOLAR = (1<<0);	
	}else{	//is rising
		low_time = T3TC;
		if ((low_time > 265) && (low_time < 285)){	//gemessen: 276
			hsync++;
			IOSET |= (1<<10); //wenn diese Zeile fehlt sind vertikale Linien zerrissen...
			y++;
			if (y<60){
				for (x = 0; x<60;x++){	  //Zeile digitalisieren und abspeichern
					pixel =	(ad_in()>>2);
					bild[x][y] = pixel;
				}  
			}
		}
		
		if ((low_time > 1600)&& (low_time < 1625) ){ //1615
			y=0;
			vsync++;
		}	
		EXTPOLAR = (0<<0);
	}
		
	VICSoftIntClr = (1<<14);
    VICVectAddr = 0;
    EXTINT=1;	    
}

void int_timer0(void)
{
	for (xp=0; xp<60; xp++){	//Bild anzeigen
		for (yp=0; yp<60; yp++){
			pset(xp*2,yp*2,colorSW(bild[xp][yp]));
		}
	}	
    displayint8(hsync*10,0,10);	 //Zeilen pro Sekunde
	displayint8(vsync*10,0,11);	 //Bilder pro Sekunde(?)
	hsync=0;
	vsync=0;
    T0IR = 1;
    VICVectAddr = 0;
}
