#include "lpc2103.h"

void init_ssp(void)
{
	PINSEL0 = PINSEL0 | 0x20000000;
	PINSEL1 = PINSEL1 | 0x00000140;
	SSPCR0 = 0x0007;    
	SSPCPSR = 2;
	SSPCR1 = 2;
}

unsigned char SSP_SendByte(unsigned char data)
{
	SSPDR = data;
	while ( SSPSR & 0x10 );
	return ( SSPDR );
}

unsigned int ad_in()
{
	ADCR |= (1<<24);
	while (!(ADGDR & (1<<31)));
	return (ADGDR>>6);
}
void init_timer_delay(void)
{
	T2PR=60;
	T2TCR = 1;
}

void delay(unsigned long us)
{
	T2TC=0;
	while (T2TC<us);
}

void init_timer3(void)
{ 
	T3TCR = 1;
	T3TC = 0; 
}


void reset_timer(void)
{
	T3TC = 0;
}

void pwm_background(unsigned short cycle)
{
	PINSEL0 |= (1<<25); //MAT1.0 P0.12
    T1TC = 0;
    T1PR = 0;
    T1MCR = (1<<10);
    cycle=2000-(cycle*20);
    T1MR0 = cycle;
    T1MR3 = 2000;
    T1PWMCON = (1<<0); //MAT1.0
    T1EMR = (1<<0)|(1<<5);
    T1TCR=1;
}

